//
//  MyLayoutManager.m
//  Stage3
//
//  Created by bill on 5/9/08.
//  Copyright 2008 __MyCompanyName__. All rights reserved.
//

#import "MyLayoutManager.h"

static NSUInteger kColumnCount = 2;
static CGFloat kYOffset = 15.0f;
static CGFloat kXOffset = 25.0f;

@implementation MyLayoutManager

+ (id)layoutManager {
	return [[[MyLayoutManager alloc] init] autorelease];
}

- (void)layoutSublayersOfLayer:(CALayer *)layer {
	NSArray *sublayers = layer.sublayers;
	NSUInteger sublayerCount = [sublayers count];
	NSUInteger rowCount = sublayerCount / kColumnCount;
	if(sublayerCount % kColumnCount > 0) {
		rowCount++;
	}
	CGFloat width = CGRectGetWidth(layer.frame);
	CGFloat height = CGRectGetHeight(layer.frame);
	CGSize maxImageSize = CGSizeMake((width - kXOffset * (kColumnCount + 1))/kColumnCount, 
									 (height - kYOffset * (rowCount + 1))/rowCount);
	for(int i = 0;i < [sublayers count];i++) {
		CALayer *sublayer = [sublayers objectAtIndex:i];
		NSUInteger column = i % kColumnCount;
		NSUInteger row = i / rowCount;
		CGFloat x = column * maxImageSize.width + (column + 1) * kXOffset;
		CGFloat y = height - ((row + 1) * (maxImageSize.height + kYOffset));
		CGRect sublayerFrame = CGRectMake(x, y, maxImageSize.width, 
										  maxImageSize.height);
		sublayer.frame = sublayerFrame;
	}
}

- (CGSize)preferredSizeOfLayer:(CALayer *)layer {
	return layer.frame.size;
}

- (void)invalidateLayoutOfLayer:(CALayer *)layer {
}

@end
